﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TelpoPush.Ability.Worker.Common
{
    public class TimeHelper
    {
        public static string ToDateString(DateTime dt)
        {
            return dt.ToString("yyyy-MM-dd");
        }
        public static DateTime ToDay23_59( DateTime dt)
        {
            return dt.AddDays(1.0).Date.AddSeconds(-1.0);
        }


        public static DateTime ToDay00_00(DateTime dt)
        {
            return dt.Date;
        }
        /// <summary>    
        /// 时间戳转为C#格式时间    
        /// </summary>    
        /// <param name=”timeStamp”></param>    
        /// <returns></returns>    
        public static DateTime ConvertTimeStampToDateTime(string timeStamp)
        {
            DateTime dtStart = TimeZoneInfo.ConvertTime(new DateTime(1970, 1, 1), TimeZoneInfo.Utc, TimeZoneInfo.Local);
            if (timeStamp.Length == 13)
            {
                long lTime = long.Parse(timeStamp + "0000");
                TimeSpan toNow = new TimeSpan(lTime);
                return dtStart.Add(toNow);
            }
            return dtStart.AddSeconds(long.Parse(timeStamp));
        }

        /// <summary>
        /// 时间类型转成时间戳毫秒
        /// </summary>
        /// <param name="time"></param>
        /// <returns></returns>
        public static long ConvertToTimeStamp(DateTime time)
        {
            long intResult = 0;
            DateTime startTime = TimeZoneInfo.ConvertTime(new DateTime(1970, 1, 1), TimeZoneInfo.Utc, TimeZoneInfo.Local);
            intResult = (long)(time - startTime).TotalMilliseconds;
            return intResult;
        }
        public static string ToDateTimeStr(DateTime dt)
        {
            return dt.ToString("yyyy-MM-dd HH:mm:ss");
        }
        public static string ToDateStr(DateTime dt)
        {
            return dt.ToString("yyyy-MM-dd");
        }

    }
}
