﻿using Confluent.Kafka;
using TelpoPush.Ability.Worker.Common;
using TelpoPush.Ability.Worker.Service.Mq;

namespace TelpoPush.Ability.Worker.Handlers
{
    public class KafkaSubscribe
    {
        private readonly ILogger<KafkaSubscribe> _logger;
        private readonly IHostEnvironment _env;
        private readonly IKafkaService _kafkaService;
        private readonly AbilityProcess _AbilityProcess;


        public KafkaSubscribe(
            ILogger<KafkaSubscribe> logger, IHostEnvironment env,
            IKafkaService kafkaService,
            AbilityProcess AbilityProcess)
        {
            _logger = logger;
            _env = env;
            _kafkaService = kafkaService;
            _AbilityProcess = AbilityProcess;
        }
        public async Task SubscribeAsync()
        {
#if DEBUG

            //https://aissjl-psychological.oss-cn-beijing.aliyuncs.com/864002051169564/1724912425/1724912425.dat
            //var temp = new Headers();
            //string topic = "topic.push.ability";
            //temp.Add(new Header("DataType", new byte[] { 14, 0, 0, 0 }));
            ////temp.Add(new Header("AlarmType", new byte[] { 2, 0, 0, 0 }));
            //string psych = "{\"messageId\":\"1834458056772617216\",\"topic\":\"topic.push.ability,topic.healthy.student\",\"time\":\"2024-09-13 13:04:17\",\"data\":{\"imei\":\"861281060080953\",\"msgId\":\"1726203844\",\"action\":\"action_messageupdate\",\"agencyId\":\"2cae99d6-0475-42fe-9fa7-ca27e03077de\",\"abilityName\":\"psych\",\"status\":\"physicalHelath_upload_success\",\"remark\":\"{\\\"imei\\\": \\\"861281060080953\\\",\\\"fileName\\\": \\\"1726203841.dat\\\"}\",\"timestamp\":1726203844000}}";
            //await _AbilityProcess.SendAbility(psych, topic, temp);
            //await _kafkaService.SubscribeAsync(DoReceive, CancellationToken.None);

#else


            LimitedConcurrencyLevelTaskScheduler lcts = new LimitedConcurrencyLevelTaskScheduler(5);
            TaskFactory factory = new TaskFactory(lcts);
            try
            {
                await factory.StartNew(async () =>
                {
                 await  _kafkaService.SubscribeAsync(DoReceive, CancellationToken.None);
                });
            }
            catch (Exception ex)
            {
                _logger.LogError($"Subscribe 处理Kafka数据发生异常 {ex.Message}|{ex.Source}|{ex.StackTrace}");
            }
#endif
        }
        async void DoReceive(string topic, string message, Headers headers)
        {
            await _AbilityProcess.SendAbility(message, topic, headers);
        }
    }
}
